module TigerPayment
  class Transaction
    attr_reader :transaction_id,
                :platform_id,
                :transaction_type,
                :condition,
                :order_id,
                :authorization_code,
                :ponumber,
                :order_description,
                :first_name,
                :last_name,
                :address_1,
                :address_2,
                :company,
                :city,
                :state,
                :postal_code,
                :country,
                :email,
                :phone,
                :fax,
                :cell_phone,
                :customertaxid,
                :customerid,
                :website,
                :shipping_first_name,
                :shipping_last_name,
                :shipping_address_1,
                :shipping_address_2,
                :shipping_company,
                :shipping_city,
                :shipping_state,
                :shipping_postal_code,
                :shipping_country,
                :shipping_email,
                :shipping_carrier,
                :tracking_number,
                :shipping_date,
                :shipping,
                :shipping_phone,
                :cc_number,
                :cc_hash,
                :cc_exp,
                :cavv,
                :cavv_result,
                :xid,
                :avs_response,
                :csc_response,
                :cardholder_auth,
                :check_account,
                :check_hash,
                :check_aba,
                :check_name,
                :account_holder_type,
                :account_type,
                :sec_code,
                :processor_id,
                :tax,
                :currency,
                :cc_bin,
                :action
                
    def initialize(params = {})
      params.each_pair do |k,v|
        if v == [{}]
          instance_variable_set('@'+k, nil)
        else
          value = Action.new(v.first) if k == 'action'
          value ||= v.size == 1 ? v.first : v
          instance_variable_set('@'+k, value)
        end
      end
    end
  end
end